var gDoneButton;
var gInfoButton;
var gMyScrollArea;
var gMyScrollbar;
var growboxInset;

var cStop = "Leipzig Hbf";
var cEva = "8010205";
var cBusTram = false;
var cAnkunft = false;


if (window.widget)
{
	widget.onhide = onhide;
	widget.onshow = onshow;
	widget.onremove = onremove;
}



function loadPrefs()
{
	if (window.widget)
	{
		var savedStop = widget.preferenceForKey(createkey("stop"));
		var savedEva = widget.preferenceForKey(createkey("eva"));
		
		if (savedStop && savedEva)
		{
			cStop = savedStop;
			cEva = savedEva;
		}
		else
		{
			cStop = "Leipzig Hbf";
			cEva = "8010205";
		}
		
		var savedBusTram = widget.preferenceForKey(createkey("bustram"));
		if (savedBusTram == "yes")
			cBusTram = true;
		else
			cBusTram = false;
		
		var savedAnkunft = widget.preferenceForKey(createkey("ankunft"));
		if (savedAnkunft == "yes")
			cAnkunft = true;
		else
			cAnkunft = false;
	}
}

function savePrefs()
{
	if (window.widget)
	{
		widget.setPreferenceForKey(cStop, createkey("stop"));
		widget.setPreferenceForKey(cEva, createkey("eva"));
		widget.setPreferenceForKey(cBusTram ? "yes" : "no", createkey("bustram"));
		widget.setPreferenceForKey(cAnkunft ? "yes" : "no", createkey("ankunft"));
	}
}

function updateUI()
{
	var element = null;
	
	element = document.getElementById("halt");
	if (element)
		element.innerHTML = cStop;
	
	element = document.getElementById("ankunft-input");
	if (element)
		element.checked = cAnkunft;
	
	element = document.getElementById("bus-input");
	if (element)
		element.checked = cBusTram;
	
	element = document.getElementById("halt-input");
	if (element)
	{
		element.value = cStop;
		element.eva = cEva;
	}
}


function onshow()
{
	fp = document.getElementById("fahrplan")
	if (fp) {
		fp.style.opacity = 0.5;
	}
	
	loadSchedule();
}

function onhide()
{
}

function onremove()
{
	if (window.widget)
	{
		widget.setPreferenceForKey(null, createkey("stop"));
		widget.setPreferenceForKey(null, createkey("eva"));
		widget.setPreferenceForKey(null, createkey("bustram"));
		widget.setPreferenceForKey(null, createkey("ankunft"));
	}
}


function startResize(event)
{
	
	document.addEventListener("mousemove", mouseMove, true);
	document.addEventListener("mouseup", mouseUp, true);
	
	growboxInset = {x:(window.innerWidth - event.x), y:(window.innerHeight - event.y)};
	
	event.stopPropagation();
	event.preventDefault();
}

function mouseMove(event)
{
	
	var x = event.x + growboxInset.x;
	var y = event.y + growboxInset.y;
	
	if (x < 250)
		x = 250; // minimum width
	if (y < 150)
		y = 150; // minimum height
	
//	var resize = document.getElementById("resize");
//	resize.style.top = (y-12);
//	resize.style.bottom = 15;
	
	window.resizeTo(x,y);
	gMyScrollArea.refresh();
	
	event.stopPropagation();
	event.preventDefault();
}


function mouseUp(event)
{
	document.removeEventListener("mousemove", mouseMove, true);
	document.removeEventListener("mouseup", mouseUp, true); 
	
	event.stopPropagation();
	event.preventDefault();
}

function createkey(key)
{
	return widget.identifier + "-" + key;
}


var doneWasClicked = false;

var lastWidth = window.innerWidth;
var lastHeight = window.innerHeight;

function showPrefs()
{
	doneWasClicked = false;
	
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
	{
		lastWidth = window.innerWidth;
		lastHeight = window.innerHeight;
		
		window.resizeTo( 319, 212);
		
		widget.prepareForTransition("ToBack");
	}
	
	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout ("widget.performTransition();", 0);
}

function hidePrefs()
{
	doneWasClicked = false;
	
	if (window.widget)
	{
		var inp = document.getElementById("halt-input");
		if (cStop != inp.value)
		{
			doneWasClicked = true;
			
			Fahrplan.validate(inp.value);
			
			isValidating = true;
			updateProgressIndicator(0);
			
			return;
		}
	}
	
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
	{
		window.resizeTo( lastWidth, lastHeight);
		
		widget.prepareForTransition("ToFront");
	}
	
	back.style.display="none";
	front.style.display="block";
	
	if (window.widget)
	{		
		document.getElementById("halt").innerHTML = cStop;
		
		setTimeout("widget.performTransition();", 0);
	}
	
    document.getElementById("myScrollArea").innerHTML = "";
    gMyScrollArea.refresh();
    
	loadSchedule();
}


function setup()
{
	loadPrefs();
	
	gDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "Done", hidePrefs);
	gInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "black", "black", showPrefs);
	
	gMyScrollbar = new AppleVerticalScrollbar(document.getElementById("myScrollbar"));
	gMyScrollArea = new AppleScrollArea(document.getElementById("myScrollArea"));
	gMyScrollArea.addScrollbar(gMyScrollbar);
	
	updateUI();
	loadSchedule();
}

var isValidating = false;
function keydown(event, input)
{
	switch (event.keyCode)
	{
		case 13: // return
		case 3:  // enter
		case 9:  // tab
			
			Fahrplan.validate(input.value);
			
			isValidating = true;
			updateProgressIndicator(0);
			
			break;
	}
}


function changeBus()
{
	document.getElementById("bus-input").checked = !document.getElementById("bus-input").checked;
	busChanged();
}

function busChanged()
{
	cBusTram = document.getElementById("bus-input").checked;
	
	if (window.widget)
		widget.setPreferenceForKey(cBusTram ? "yes" : "no", createkey("bustram"));
}

function changeAnkunft()
{
	document.getElementById("ankunft-input").checked = !document.getElementById("ankunft-input").checked;
	ankunftChanged();
}

function ankunftChanged()
{
	cAnkunft = document.getElementById("ankunft-input").checked;
	
	if (window.widget)
		widget.setPreferenceForKey(cAnkunft ? "yes" : "no", createkey("ankunft"));
}


function errorCallback(msg)
{
	isLoading = false;
	setStatus("");
	
	isValidating = false;
	setProgressIndicator("");
    
    document.getElementById("myScrollArea").innerHTML = msg;
    gMyScrollArea.refresh();
}

function loadCallback(data)
{
	document.getElementById("myScrollArea").innerHTML = data;
	document.getElementById("fahrplan").style.opacity = 1;
	
	gMyScrollArea.refresh();
	
	isLoading = false;
	setStatus("");
	
	isValidating = false;
	setProgressIndicator("");
}

function validationCallback(options)
{
	isLoading = false;
	setStatus("");
	
	isValidating = false;
	setProgressIndicator("");
	
	var menu = null;
	var inp = document.getElementById("halt-input");
	
	if (options.length == 1)
	{
		cStop = options[0][0]; // name
		cEva = options[0][1]; // eva
		
		inp.value = cStop;
		inp.eva = cEva;
		
		if (window.widget)
		{
			widget.setPreferenceForKey(cStop, createkey("stop"));
			widget.setPreferenceForKey(cEva, createkey("eva"));
		}
		
		if (doneWasClicked)
			setTimeout("hidePrefs()", 0);
		
		return;
	}
	
	if (window.widget)
		menu = widget.createMenu();
	
	if (menu != null)
	{
		var c = options.length;
		for (var i = 0; i < c; i++)
		{
			menu.addMenuItem(options[i][0]);
		}
		
		var selectedItem = menu.popup(35, 112);
		
		if (selectedItem >= 0)
		{
			cStop = options[selectedItem][0];
			cEva = options[selectedItem][1];
			
			inp.value = cStop;
			inp.eva = cEva;
			
			widget.setPreferenceForKey(cStop, createkey("stop"));
			widget.setPreferenceForKey(cEva, createkey("eva"));
			
			if (doneWasClicked)
				setTimeout("hidePrefs()", 0);
		}
	}
	
	doneWasClicked = false;
}


function setStatus(msg)
{
	document.getElementById("status").innerHTML = msg;
}

function setProgressIndicator(msg)
{
	document.getElementById("progressindicator").innerHTML = msg;
}

var s0 = "";
var s1 = ".";
var s2 = "..";
var s3 = "...";
function updateStatus(c)
{
	if (!isLoading)
		return;
	
	setTimeout("setStatus('Aktueller Fahrplan wird geladen'+s"+(c%4)+");", 0);
	setTimeout("updateStatus("+(c+1)+");", 333);
}

function updateProgressIndicator(c)
{
	if (!isValidating)
		return;
	
	setTimeout("setProgressIndicator(s"+(c%4)+");", 0);
	setTimeout("updateProgressIndicator("+(c+1)+");", 333);
}


function visitWebsite()
{
	if (window.widget)
		widget.openURL("http://www.vercruesse.de");
}

var isLoading = false;
function loadSchedule()
{
	var success;
	
	if (cAnkunft)
		success = Fahrplan.arrivals(cEva, cBusTram);
	else
		success = Fahrplan.departures(cEva, cBusTram);
	
	if (success)
	{
		isLoading = true;
		updateStatus(0);
		
//		document.getElementById("myScrollArea").innerHTML = "";
//		gMyScrollArea.refresh();
	}
	else
	{
		setTimeout("loadSchedule();", 250);
	}
}
